CON
 
  msize   =   64           ' adjust per installed system memory (K bytes)
  bioslen = $d00           ' CBIOSX.COM (3328) adjust as bios changes are made (if necessary)
  ccplen  = $800           ' CCP.COM (2048) cp/m constant
  bdoslen = $e00           ' BDOS.COM(3584) cp/m constant
   
  ' cp/m image size (rounded up to next 1k boundary)
  cpmlen = (ccplen + bdoslen + bioslen + $3ff) / $400     '  => 9
   
  ccpph   =     (msize - cpmlen) * 1024         ' ccp start address   (56320 : $DC00) 
  bdosph  =     ccpph + ccplen                  ' bdos start address  (58368 : $E400)
  biosph  =     ccpph + ccplen + bdoslen        ' bios start address  (61952 : $F200)
   
  bdos    =     bdosph + 6                      ' Entry point for BDOS

  

VAR                   

  'byte  buffer[256]


OBJ
  ram     : "SRAM-XMM"

PUB LoadSRAM
  'Copy  CBIOSX.COM (3328), CCP.COM (2048) and BDOS.COM(3584) to SRAM
  ram.start
  ram.DoCmd("W", @ram_page0, 0, 256)                    ' copy page 0
  ram.DoCmd("W", @ccp_, ccpph, ccplen)                  ' copy CCP.COM
  ram.DoCmd("W", @bdos_, bdosph, bdoslen)               ' copy BDOS.COM
  ram.DoCmd("W", @cbiosx_, biosph, bioslen)             ' copy CBIOSX.COM
  ram.DoCmd("W", @rom_8080, $FF00, 256)                 ' copy DSKBOOT.COM

  'ram.DoCmd("X", 0, 0, 0)
  ram.stop

DAT
                             
ram_page0


              'start CPM directly from RAM image, no disks (SD card) required for boot up
              BYTE $C3, biosph & $FF, (biosph >> 8) & $FF

              'Un-comment line below to run the disk boot code from ROM space and boot CP/M from disk (SD card)
              'BYTE $C3, $00, $FF

              'Place a jump to BDOS at location $0005
              BYTE 0[2]
              BYTE $C3, bdos & $FF, (bdos >> 8) & $FF
              BYTE 0[8]


              'Pad out with zeros until the start of the Transient Program Area at $100
              BYTE 0[15 * 16]


              'Console Command Processor compiled from original Digital Research source.
ccp_          file "CCP.COM"                  ' 2048 bytes

              'Basic Disk Operating System compiled from original Digital Resarch source
bdos_         file "BDOS.COM"                 ' 3584 bytes

              'Customized BIOS of the SIMH Altair Emulator Project
cbiosx_       file "CBIOSX.COM"               ' 3328 bytes


ram_end

              'The Altair boot rom. This read as rom located $FF00 by the cpu emulator
              'This file is the result of assembling DSKBOOT.MAC inside the SIMH Altair 8800 simulator.
rom_8080      file "DSKBOOT.COM"    ' 384 bytes



        
